﻿using System;
using System.Data.SqlClient;

namespace CallbackMethodSample
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection con = new SqlConnection(@"Data Source=.\sqlexpress;Initial Catalog=Northwind;Integrated Security=SSPI;Asynchronous Processing=true");
            string strSQL = "SELECT * FROM Products";
            SqlCommand cmd = new SqlCommand(strSQL, con);
            con.Open();
            // Delegaten initialisieren
            AsyncCallback callback = new AsyncCallback(CallbackMethod);
            // Asynchrone operation starten
            cmd.BeginExecuteReader(callback, cmd);

            for (int counter = 0; counter < 100; counter++)
            {
                Console.WriteLine(new string('-', 50));
                Console.WriteLine("Counter = {0}", counter);
            }
            Console.ReadLine();
        }


        static void CallbackMethod(IAsyncResult result)
        {
            SqlCommand cmd = (SqlCommand)result.AsyncState;
            // Ergenisliste holen
            SqlDataReader rd = cmd.EndExecuteReader(result);
            while (rd.Read())
                Console.WriteLine(rd["ProductName"]);
            rd.Close();
        }
    }

}
