﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace SchemaPerCode
{
    class Program
    {
        static void Main(string[] args) {
            SqlConnection con = new SqlConnection();
            con.ConnectionString = @"Data Source=.\sqlexpress;Database=Northwind;Integrated Security=true";
            SqlCommand cmd = new SqlCommand();
            cmd.Connection = con;
            cmd.CommandText = "SELECT ProductID, ProductName, CategoryID, QuantityPerUnit, Discontinued FROM Products";
            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            da.Fill(ds);
            FillSchemaInfos(ds.Tables[0]);
            // Der Artikelbezeichner des Artikels in der ersten Datenzeile
            // soll geändert werden
            DataRow row = ds.Tables[0].Rows[0];
            Console.Write("Produktname ändern: ");
            row["ProductName"] = Console.ReadLine();
            // Änderung in die Originaldatenbank schreiben
            SqlCommandBuilder cmb = new SqlCommandBuilder(da);
            da.Update(ds);
            Console.WriteLine("Aktualisierung erfolgreich.");
            Console.ReadLine();
        }


        // Diese Methode füllt die Tabelle mit Schemainformationen
        static void FillSchemaInfos(DataTable tbl)
        {
            //  ProductID
            tbl.PrimaryKey = new DataColumn[] { tbl.Columns["ProductID"] };
            //  ProductName
            tbl.Columns["ProductName"].MaxLength = 40;
            tbl.Columns["ProductName"].AllowDBNull = false;
            //  QuantityPerUnit
            tbl.Columns["QuantityPerUnit"].MaxLength = 20;
            //  Discontinued
            tbl.Columns["Discontinued"].AllowDBNull = false;
        }
    }

}
