﻿using System;
using System.Data;
using System.Data.SqlClient;

namespace ManuelleAktualisierung
{
    class Program
    {
        static void Main(string[] args)
        {
            SqlConnection con = new SqlConnection();
            con.ConnectionString = @"Data Source=.\sqlexpress;Database=Northwind;Integrated Security=true";
            SqlCommand cmd = new SqlCommand();
            cmd.CommandText = "SELECT ProductID, ProductName, Unitprice, UnitsInStock, Discontinued FROM Products";
            cmd.Connection = con;

            DataSet ds = new DataSet();
            SqlDataAdapter da = new SqlDataAdapter(cmd);
            SqlCommandBuilder cmb = new SqlCommandBuilder(da);
            da.UpdateCommand = CreateUpdateCommand(con);
            da.FillSchema(ds, SchemaType.Source);
            ds.Tables[0].Columns[0].AutoIncrementSeed = -1;
            ds.Tables[0].Columns[0].AutoIncrementStep = -1;
            da.Fill(ds);

            // Datenzeilen ändern
            ChangeDataRows(ds);

            // Datenzeilen hinzufügen
            AddDataRows(ds);

            // Simulation eines Konflikts
            Console.Write("Konflikt simulieren ...");
            Console.ReadLine();

            // Datenbank aktualisieren
            da.Update(ds);
            Console.WriteLine("Datenbank ist aktualisiert.");
            Console.ReadLine();
        }

        static SqlCommand CreateUpdateCommand(SqlConnection con)
        {
            string sql = "UPDATE Products SET ProductName=@p1, UnitPrice=@p2, UnitsInStock=@p3 WHERE ProductID=@p4 AND ProductName= @p5 AND UnitPrice=@p6";

            SqlCommand cmd = new SqlCommand(sql, con);
            cmd.Parameters.Add("@p1", SqlDbType.VarChar, 40, "ProductName");
            cmd.Parameters.Add("@p2", SqlDbType.Money, 8, "UnitPrice");
            cmd.Parameters.Add("@p3", SqlDbType.SmallInt, 2, "UnitsInStock");
            cmd.Parameters.Add("@p4", SqlDbType.Int, 4, "ProductID");

            SqlParameter param;
            param = cmd.Parameters.Add("@p5", SqlDbType.VarChar, 40, "ProductName");
            param.SourceVersion = DataRowVersion.Original;

            param = cmd.Parameters.Add("@p6", SqlDbType.Money, 8, "UnitPrice");
            param.SourceVersion = DataRowVersion.Original;
            return cmd;
        }

        static void ChangeDataRows(DataSet ds)
        {
            ds.Tables[0].Rows[0]["ProductName"] = "Pfeffer";
            ds.Tables[0].Rows[1]["Productname"] = "Salz";
            ds.Tables[0].Rows[2]["Productname"] = "Banane";
            ds.Tables[0].Rows[3]["Productname"] = "Orange";
            ds.Tables[0].Rows[4]["Productname"] = "Mango";
            ds.Tables[0].Rows[5]["UnitsInStock"] = 125;
            ds.Tables[0].Rows[6]["UnitsInStock"] = 55;
        }

        static void AddDataRows(DataSet ds)
        {
            DataRow row1 = ds.Tables[0].NewRow();
            row1["Productname"] = "Suppenhuhn";
            row1["Discontinued"] = 0;
            ds.Tables[0].Rows.Add(row1);
            DataRow row2 = ds.Tables[0].NewRow();
            row2["Productname"] = "Aachener Printe";
            row2["Discontinued"] = 0;
            ds.Tables[0].Rows.Add(row2);
        }
    }
}
